dj/urls.py
from django.conf.urls import url
import django.contrib.auth.views

from dj import views

urlpatterns = [
    url(r'^$', views.HomeView.as_view(),
        name='home'),
    url(r'^vote$', views.VoteSongView.as_view(),
        name='vote'),
    url(r'^login$', views.LoginView.as_view(),
        name='login'),
    url(r'^logout$',
        django.contrib.auth.views.logout_then_login,
        name='logout'),
    url(r'^suggest$',
        views.SuggestSongView.as_view(),
        name='suggest'),
    url(r'^validate$',
        views.ValidateSongView.as_view(),
        name='validate'),

    # Stubs
    url(r'^stub/now-playing$',
        views.NowPlayingStubView.as_view(),
        name='stub-now-playing'),
    url(r'^stub/playing-next$',
        views.PlayingNextStubView.as_view(),
        name='stub-playing-next'),

    # Player control
    url(r'^volume$', views.VolumeView.as_view(),
        name='volume'),
    url(r'^skip$', views.SkipSongView.as_view(),
        name='skip'),
]

urls.py
from django.conf.urls import include
from django.conf.urls import url
from django.contrib import admin

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^', include('dj.urls', namespace='dj')),
    url(r'', include('django_prometheus.urls')),
]

dj/models.py
from django.conf import settings
from django.db import models
from django.db.models import Count
from django.utils import timezone
from django.utils.functional import cached_property
from django_prometheus.models import ExportModelOperationsMixin

import dj.source
from dj.templatetags.djutils import elapsed


class BaseSong(models.Model):
    title = models.CharField(max_length=256, verbose_name="Title")
    artist = models.CharField(max_length=256,
                              verbose_name="Artist",
                              blank=True)
    duration = models.IntegerField(verbose_name="Duration",
                                   help_text="In seconds.")

    @cached_property
    def human_duration(self):
        return elapsed(self.duration)

    def __str__(self):
        return "{}{} ({})".format(self.artist + " – " if self.artist else "",
                                  self.title, elapsed(self.duration))

    class Meta:
        abstract = True


class SongManager(models.Manager):
    def get_queryset(self):
        return (super().get_queryset().annotate(vote_count=Count('votes'))
                .order_by('-vote_count', 'id'))


class Song(ExportModelOperationsMixin('song'), BaseSong):
    """
    Represents a validated song that can be played.
    """

    objects = SongManager()

    path = models.CharField(max_length=512,
                            verbose_name="Path to file",
                            unique=True)
    votes = models.ManyToManyField(settings.AUTH_USER_MODEL,
                                   related_name='voted_songs',
                                   verbose_name="Votes by users",
                                   blank=True)


class PendingSong(ExportModelOperationsMixin('pending_song'), BaseSong):
    """
    Represents a song waiting to be validated.
    """

    submitter = models.ForeignKey(settings.AUTH_USER_MODEL,
                                  on_delete=models.CASCADE,
                                  related_name='submitted_songs',
                                  verbose_name="Submitter")
    banned = models.BooleanField(
        default=False,
        verbose_name="Banned",
        help_text="Any further submissions of this song will be automatically nuked.")
    source = models.CharField(max_length=16, verbose_name="Source")
    identifier = models.CharField(max_length=256, verbose_name="Identifier")

    class Meta:
        ordering = ('banned', '-id')
        unique_together = ('source', 'identifier')

    @cached_property
    def url(self):
        return self.source_class().get_url(self.identifier)

    def source_class(self) -> dj.source.SongSource:
        return dj.source.from_code(self.source)


class Player(models.Model):
    """
    Represents the state of the player.
    """

    song = models.ForeignKey(Song,
                             on_delete=models.SET_NULL,
                             null=True,
                             blank=True,
                             verbose_name="Current song")
    start_time = models.DateTimeField(
        null=True,
        blank=True,
        verbose_name="Current song starting time")

    @classmethod
    def instance(cls):
        return cls.objects.first()

    def is_playing(self):
        return all(attr is not None for attr in (self.song, self.start_time))

    def set_next_song(self, song):
        self.song = song
        self.start_time = timezone.now()

    def __str__(self):
        if self.is_playing():
            return "Playing: %s" % self.song
        else:
            return "Not playing"

dj/forms.py
from crispy_forms.helper import FormHelper
from crispy_forms.layout import Layout
from crispy_forms.bootstrap import PrependedText, StrictButton
from django.contrib.auth.forms import AuthenticationForm


class DjAuthenticationForm(AuthenticationForm):
    helper = FormHelper()
    helper.form_tag = True
    helper.form_show_labels = False
    helper.layout = Layout(
        PrependedText('username',
                      '<i class="fa fa-user"></i>'),
        PrependedText('password',
                      '<i class="fa fa-lock"></i>'),
        StrictButton('Connect',
                     css_class='btn-default btn-block',
                     type='submit'), )

dj/views.py
import logging
import os

from django.conf import settings
from django.contrib import messages
from django.contrib.auth import authenticate, login, REDIRECT_FIELD_NAME
from django.core.exceptions import SuspiciousOperation
from django.core.signing import BadSignature
from django.core.urlresolvers import reverse_lazy, reverse
from django.db import IntegrityError
from django.db import transaction
from django.db.models import Q
from django.http.response import HttpResponseBadRequest, HttpResponseRedirect, \
    HttpResponse
from django.shortcuts import redirect, resolve_url
from django.utils import timezone
from django.utils.decorators import method_decorator
from django.utils.functional import cached_property
from django.utils.html import format_html
from django.utils.http import is_safe_url
from django.views.decorators.csrf import csrf_exempt
from django.views.generic import View, ListView
from django.views.generic.edit import FormView, CreateView, UpdateView, \
    ModelFormMixin
from rules.contrib.views import PermissionRequiredMixin

import dj.forms
import dj.models
import dj.player
import dj.source

logger = logging.getLogger('dj.views')


def validate_download_song(pending_song):
    with transaction.atomic():
        cls = dj.source.from_code(pending_song.source)
        path = cls.download(pending_song.identifier)
        path = os.path.relpath(path, settings.MPD_MUSIC_ROOT)
        song = dj.models.Song(artist=pending_song.artist,
                              title=pending_song.title,
                              duration=pending_song.duration,
                              path=path)
        song.save()
        if pending_song.pk is not None:
            pending_song.delete()
    return song


class HomeView(PermissionRequiredMixin, ListView):
    template_name = "dj/index.html"
    model = dj.models.Song
    next_count = 5
    context_object_name = 'songs'
    permission_required = "dj.browse"

    def get_queryset(self):
        return super().get_queryset()[:self.next_count]

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)

        player = dj.models.Player.instance()
        if player.is_playing():
            context['current_song'] = player.song
            context['current_elapsed'] = timezone.now() - player.start_time
        context['volume'] = dj.player.get_volume()
        return context


class VoteSongListView(ListView):
    # Permission checking is done in VoteSongView
    template_name = 'dj/vote.html'
    model = dj.models.Song
    context_object_name = 'songs'
    paginate_by = 20

    @cached_property
    def search_query(self):
        return self.request.GET.get('q', '').strip()

    def get_queryset(self):
        qs = super().get_queryset().prefetch_related('votes')
        query = self.search_query
        if query:
            qs = qs.filter(Q(title__icontains=query) | Q(
                artist__icontains=query))
        return qs


class VoteOrUnvoteSongView(UpdateView):
    # Permission checking is done in VoteSongView
    model = dj.models.Song
    fields = []

    def get_success_url(self):
        return self.request.POST['next']

    def get_object(self, queryset=None):
        return (queryset or self.get_queryset()).get(
            pk=self.request.POST['song_id'])

    def form_invalid(self, form):
        return HttpResponseBadRequest()

    def form_valid(self, form):
        try:
            method = self.request.POST['action']
            if method not in ('add', 'remove'):
                raise AttributeError()
            getattr(self.object.votes, method)(self.request.user)
            return super(ModelFormMixin, self).form_valid(form)
        except Exception:
            return HttpResponseBadRequest()


class VoteSongView(PermissionRequiredMixin, View):
    permission_required = 'dj.vote_song'

    def get(self, request, *args, **kwargs):
        return VoteSongListView.as_view()(request, *args, **kwargs)

    def post(self, request, *args, **kwargs):
        return VoteOrUnvoteSongView.as_view()(request, *args, **kwargs)


class SuggestSongView(PermissionRequiredMixin, CreateView):
    template_name = 'dj/suggest.html'
    model = dj.models.PendingSong
    queryset = model.objects.filter(banned=False)
    fields = ['artist', 'title']
    context_object_name = 'songs'
    pending_song_count = 5
    per_source_results = 5
    success_url = reverse_lazy('dj:suggest')
    permission_required = 'dj.suggest_song'

    @cached_property
    def search_query(self):
        return self.request.GET.get('q', '').strip().lower()

    def get_success_url(self):
        if self.search_query:
            return '{}?q={}'.format(self.success_url, self.search_query)
        return self.success_url

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        # Source list
        context['available_sources'] = [source.source_name
                                        for source in dj.source.all()]
        # Add a few songs from pending songs
        context['pending_songs'] = self.get_queryset()[:
                                                       self.pending_song_count]
        # Execute search if needed
        q = self.search_query
        if q:
            search_results = []
            for source in dj.source.all():
                search_results.extend(source.search(q)[:self.per_source_results])
            context['search_results'] = search_results
        return context

    def form_valid(self, form):
        # Save new suggestion (or error out if banned)
        pending_song = self.object = form.save(commit=False)
        pending_song.submitter = self.request.user
        try:
            dj.source.SongSource.load(self.request.POST['state'], pending_song)
        except KeyError:
            return HttpResponseBadRequest()
        except BadSignature:
            return SuspiciousOperation("Malformed SerializableSong state")
        try:
            if self.request.user.has_perm(
                    'dj.validate_song') and self.request.POST.get(
                        'instant_validate'):
                messages.success(self.request,
                                 format_html("{} was added and validated.",
                                             pending_song))
                validate_download_song(pending_song)
            else:
                with transaction.atomic():
                    pending_song.save()
                messages.success(self.request, format_html(
                    "{} was added to validation queue.", pending_song))
            return super(ModelFormMixin, self).form_valid(form)
        except IntegrityError:
            banned = self.model.objects.filter(
                identifier=pending_song.identifier,
                banned=True).exists()
            if banned:
                form.add_error(None, "This song is banned from suggestions.")
            else:
                form.add_error(None,
                               "This song is already pending validation.")
            return self.form_invalid(form)


class ValidateSongView(PermissionRequiredMixin, View):
    permission_required = 'dj.validate_song'

    def get(self, request, *args, **kwargs):
        return ValidateSongListView.as_view()(request, *args, **kwargs)

    def post(self, request, *args, **kwargs):
        return ValidateOrNukeSongView.as_view()(request, *args, **kwargs)


class ValidateSongListView(ListView):
    # Permission checking is done in ValidateSongView
    template_name = 'dj/validate.html'
    model = dj.models.PendingSong
    context_object_name = 'pending_songs'
    paginate_by = 20


class ValidateOrNukeSongView(UpdateView):
    # Permission checking is done in ValidateSongView
    model = dj.models.PendingSong
    fields = ['artist', 'title']
    success_url = reverse_lazy('dj:validate')

    def get_object(self, queryset=None):
        if queryset is None:
            queryset = self.get_queryset()
        return queryset.get(pk=self.request.POST['song_id'])

    def form_invalid(self, form):
        print(form.errors)
        return redirect(reverse('dj:validate'))

    def form_valid(self, form):
        try:
            decision = self.request.POST['decision']
            self.object = form.save(commit=False)
            if decision == 'ban':
                if self.object.banned:
                    return HttpResponseBadRequest()
                else:
                    self.object.banned = True
                    self.object.save()
            elif decision == 'unban':
                if self.object.banned:
                    self.object.banned = False
                    self.object.save()
                else:
                    return HttpResponseBadRequest()
            elif decision == 'validate':
                validate_download_song(self.object)
            elif decision == 'nuke':
                self.object.delete()
            return super(ModelFormMixin, self).form_valid(form)
        except KeyError:
            return HttpResponseBadRequest()


class LoginView(FormView):
    template_name = 'dj/login.html'
    form_class = dj.forms.DjAuthenticationForm
    redirect_field_name = REDIRECT_FIELD_NAME

    def form_valid(self, form):
        redirect_to = self.request.POST.get(self.redirect_field_name,
                                            self.request.GET.get(
                                                self.redirect_field_name, ''))
        user = authenticate(username=form.cleaned_data['username'],
                            password=form.cleaned_data['password'])
        if user is not None:
            login(self.request, user)
            if not is_safe_url(url=redirect_to, host=self.request.get_host()):
                redirect_to = resolve_url(settings.LOGIN_REDIRECT_URL)
            login(self.request, form.get_user())
            return HttpResponseRedirect(redirect_to)

dj/templates/dj/base.html
{% load staticfiles %}

<!DOCTYPE html>
<html lang="en">
  <head>
    {% block meta_tags %}
    <meta charset="utf-8"/>
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
    <link rel="icon" href="{% static 'favicon.png' %}">
    {% endblock %}
    <title>{% block title %} – DJ Ango{% endblock %}</title>
    {% block stylesheets %}
    <link href="{% static 'css/font-awesome.min.css' %}" rel="stylesheet">
    <link href="{% static 'css/bootstrap.min.css' %}" rel="stylesheet">
    <link href="{% static 'css/theme.min.css' %}" rel="stylesheet">
    <link href="{% static 'css/dj_ango.css' %}" rel="stylesheet">
    {% endblock %}
    {% block javascript %}
    <script type='text/javascript' src="{% static 'js/jquery.min.js' %}"></script>
    <script type='text/javascript' src="{% static 'js/bootstrap.min.js' %}"></script>
    <script type='text/javascript' src="{% static 'js/dj_ango.js' %}"></script>
    {% endblock %}
  </head>
  <body>
  {% include "dj/header.html" %}
    <div class="container">
      {% include "dj/stub_messages.html" %}
      {% block content %}{% endblock %}
    </div>
  </body>
</html>

dj/templates/dj/header.html
{% load rules %}

<header class="navbar navbar-default">
  <div class="navbar-header">
    <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
      <span class="sr-only">Toggle navigation</span>
      <span class="icon-bar"></span>
      <span class="icon-bar"></span>
      <span class="icon-bar"></span>
    </button>
    <a class="navbar-brand" rel="home" href="{% url 'dj:home' %}">DJ Ango</a>
  </div>
  <div class="collapse navbar-collapse">
    <ul class="nav navbar-nav navbar-right">
    {% if request.user.is_authenticated %}
      <li><a href="{% url 'dj:home' %}">
        <i class="fa fa-volume-up"></i> Now playing</a>
      </li>
      <li><a href="{% url 'dj:vote' %}">
        <i class="fa fa-thumbs-up"></i> Vote</a>
      </li>
      <li><a href="{% url 'dj:suggest'%}">
        <i class="fa fa-cloud-upload"></i> Suggest</a>
      </li>
    {% has_perm 'dj.validate_song' request.user as can_validate_songs %}
    {% if can_validate_songs %}
      <li><a href="{% url 'dj:validate'%}">
        <i class="fa fa-check"></i> Validate</a>
      </li>
    {% endif %}
    {% endif %}
    {% if request.user.is_staff %}
      <li><a href="{% url 'admin:index' %}"><i class="fa fa-star"></i> Admin</a></li>
    {% endif %}
      <li><a {% if request.user.is_authenticated %}href="{% url 'dj:logout' %}" title="Log out"{% else %}href="{% url 'dj:login' %}" title="Log in"{% endif %}>
        <i class="fa fa-user"></i> {% if request.user.is_authenticated %}{{request.user.username}}{% else %}Log in{% endif %}</a>
      </li>
    </ul>
  </div>
</header>

dj/templates/dj/index.html
{% extends "dj/base.html" %}
{% load rules %}

{% block title %}Now playing{{ block.super }}{% endblock %}

{% block content %}

  <div class="row">
    <div class="col-md-6 col-md-offset-3">
      <div class="row">
        <div class="col-xs-12">
          <div class="well">
            <h4>Now playing</h4>
            <div id="stub-now-playing">
            {% include "dj/index_stub_now_playing.html" %}
            </div>
            {% has_perm 'dj.skip_song' request.user as can_skip_song %}
            {% has_perm 'dj.set_volume' request.user as can_set_volume %}
            {% if can_set_volume or can_skip_song %}
              <hr>
              <h4>Control panel</h4>
              {% if can_set_volume %}
                <p>Volume: <input type="range" min="0" max="100" id="volume" value="{{ volume }}">
                </p>
              {% endif %}
              {% if can_set_volume %}
                <form action="{% url 'dj:skip' %}" method="post">
                  {% csrf_token %}
                  <button type="submit" name="skip" class="btn btn-warning">
                    <i class="fa fa-forward"></i> Skip song
                  </button>
                </form>
              {% endif %}
            {% endif %}
            <hr>
            <h4>Coming next</h4>
            <div id="stub-playing-next">
              {% include "dj/index_stub_playing_next.html" %}
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>

{% endblock %}

dj/templates/dj/index_stub_now_playing.html
{% load djutils %}

{% if current_song %}

  <div class="pull-right">
    <span id="timer" data-duration="{{ current_song.duration }}"
          data-elapsed="{{ current_elapsed.total_seconds }}">
      {{ current_elapsed|elapsed }}</span>/{{ current_song.duration|elapsed }}
  </div>
  <p>
    {% if current_song.artist %}{{ current_song.artist }} –{% endif %}
    {{ current_song.title }}
  </p>
  <div class="progress" style="background-color: #666">
    <div id="timer-bar" class="progress-bar progress-bar-success"
         role="progressbar" aria-valuenow="0" aria-valuemin="0"
         aria-valuemax="100" style="width: 0%"></div>
  </div>

{% else %}

  {# No song placeholder #}
  <div class="progress" style="background-color: #666">
    <div class="progress-bar progress-bar-danger progress-bar-striped active"
         style="width: 100%">
      <i class="fa fa-frown-o"></i> <em>No song</em>
    </div>
  </div>

{% endif %}

dj/templates/dj/index_stub_playing_next.html
{% if songs %}

  <table class="table table-striped">
    <thead>
    <tr>
      <th></th>
      <th>Artist</th>
      <th>Title</th>
      <th>Duration</th>
      <th>Votes</th>
      <th></th>
    </tr>
    </thead>
    <tbody>
    {% for song in songs %}
      <tr>
        <td>{{ forloop.counter }}</td>
        <td>{{ song.artist }}</td>
        <td>{{ song.title }}</td>
        <td>{{ song.human_duration }}</td>
        <td>{{ song.vote_count }}</td>
        <td>
          <form action="{% url 'dj:vote' %}" method="post">
            {% csrf_token %}
            <input type="hidden" name="song_id" value="{{ song.pk }}">
            <input type="hidden" name="next" value="{% url 'dj:home' %}">
            {% if request.user in song.votes.all %}
              <button class="btn btn-danger btn-xs" name="action"
                      value="remove">
                <i class="fa fa-thumbs-down"></i>
              </button>
            {% else %}
              <button class="btn btn-success btn-xs" name="action" value="add">
                <i class="fa fa-thumbs-up"></i>
              </button>
            {% endif %}
          </form>
        </td>
      </tr>
    {% endfor %}
    </tbody>
  </table>

  <p><a href="{% url 'dj:vote' %}" class="btn btn-default btn-block"><i class="fa fa-angle-double-right"></i> Browse all votes</a></p>

{% else %}

  <div class="alert alert-danger"><i class="fa fa-frown-o"></i> <div><em>No song.</em></div></div>

{% endif %}

dj/templates/dj/login.html
{% extends "dj/base.html" %}
{% load crispy_forms_tags %}

{% block title %}Login{{ block.super }}{% endblock %}

{% block content %}

  <div class="row">
    <div class="col-md-4 col-md-offset-4">
      <div class="panel panel-default">
        <div class="panel-heading"><h3 class="panel-title">Log in</h3></div>
        <div class="panel-body">
          {% crispy form %}
        </div>
      </div>
    </div>
  </div>

{% endblock %}

dj/templates/dj/stub_messages.html
{% if messages %}
  {% for message in messages %}
    {% if message.level == DEFAULT_MESSAGE_LEVELS.ERROR %}
      <div class="alert alert-dismissable alert-danger">
      <button type="button" class="close" data-dismiss="alert"
              aria-hidden="true">&times;</button>
      <i class="fa fa-times-circle"></i>
    {% elif message.level == DEFAULT_MESSAGE_LEVELS.WARNING %}
      <div class="alert alert-dismissable alert-warning">
      <button type="button" class="close" data-dismiss="alert"
              aria-hidden="true">&times;</button>
      <i class="fa fa-exclamation-triangle"></i>
    {% elif message.level == DEFAULT_MESSAGE_LEVELS.SUCCESS %}
      <div class="alert alert-dismissable alert-success">
      <button type="button" class="close" data-dismiss="alert"
              aria-hidden="true">&times;</button>
      <i class="fa fa-check-circle"></i>
    {% else %}
      <div class="alert alert-dismissable alert-info">
      <button type="button" class="close" data-dismiss="alert"
              aria-hidden="true">&times;</button>
      <i class="fa fa-info-circle"></i>
    {% endif %}
  <div>{{ message|safe }}</div>
  </div>
  {% endfor %}
{% endif %}

dj/templates/dj/stub_pagination.html
{% if is_paginated %}
  <div class="text-center">
    <ul class="pagination pagination-centered">
      <li {% if not page_obj.has_previous %}class="disabled"{% endif %}>
        <a href="?page=1">
          <i class="fa fa-angle-double-left"></i></a></li>
      <li {% if not page_obj.has_previous %}class="disabled"{% endif %}>
        <a href="{% if page_obj.has_previous %}?page={{ page_obj.previous_page_number }}{% else %}#{% endif %}">
          <i class="fa fa-angle-left"></i></a></li>

      {% for i in paginator.page_range %}
        <li {% if page_obj.number == i %}class="active"{% endif %}><a
          href="?page={{ i }}">{{ i }}</a></li>
      {% endfor %}

      <li {% if not page_obj.has_next %}class="disabled"{% endif %}>
        <a href="{% if page_obj.has_next %}?page={{ page_obj.next_page_number }}{% else %}#{% endif %}">
          <i class="fa fa-angle-right"></i></a></li>
      <li {% if not page_obj.has_next %}class="disabled"{% endif %}>
        <a href="?page={{ page_obj.paginator.num_pages }}">
          <i class="fa fa-angle-double-right"></i></a></li>
    </ul>
  </div>
{% endif %}

dj/templates/dj/suggest.html
{% extends "dj/base.html" %}

{% block title %}Suggest songs{{ block.super }}{% endblock %}

{% block content %}

  <h1 class="text-center">Suggest songs</h1>

  {% include "dj/suggest_stub_search.html" %}

  {% comment %}
  {% if user.is_superuser %}
    <div class="panel panel-default">
      <div class="panel-heading"><h3 class="panel-title">Upload</h3></div>
      {% include "dj/suggest_stub_upload.html" %}
    </div>
  {% endif %}
  {% endcomment %}
  <div class="panel panel-default">
    <div class="panel-heading"><h3 class="panel-title">Songs waiting for
      validation</h3></div>
    {% include "dj/suggest_stub_pending.html" %}
  </div>

{% endblock %}

dj/templates/dj/suggest_stub_pending.html
<div class="panel-body">
  {% if pending_songs %}
    <table class="table table-striped">
      <thead>
      <tr>
        <th>Artist</th>
        <th>Title</th>
        <th>Duration</th>
        <th>Source</th>
      </tr>
      </thead>
      <tbody>
      {% for song in pending_songs %}
        <tr>
          <td>{{ song.artist }}</td>
          <td>{{ song.title }}</td>
          <td>{{ song.human_duration }}</td>
          <td>
            <i class="fa fw-fw fa-{{ song.source_class.source_icon }}"></i> {{ song.source_class.source_name }}
          </td>
        </tr>
      {% endfor %}
      </tbody>
    </table>
  {% else %}
    <em>No pending song.</em>
  {% endif %}
</div>

dj/templates/dj/suggest_stub_upload.html
<div class="panel-body">
  <form method="post" action="add_upload" enctype="multipart/form-data">{% csrf_token %}
    <div class="row">
      <div class="col-xs-6">
        <div class="input-group">
          <span class="input-group-addon">Title</span>
          <input type="text" name="title" class="form-control" placeholder="mandatory" required>
        </div>
      </div>
      <div class="col-xs-6">
        <div class="input-group">
          <span class="input-group-addon">Artist</span>
          <input type="text" name="artist" class="form-control" placeholder="optional">
        </div>
      </div>
    </div>
    <br/>
    <div class="row">
      <div class="col-xs-10">
        <div class="input-group">
          <span class="input-group-addon">File</span>
          <input type="file" name="file" class="filestyle" data-buttonText="">
        </div>
      </div>
      <div class="col-xs-2">
        <button class="btn btn-default" type="submit" style="width: 100%">Upload</button>
      </div>
    </div>
  </form>
</div>

dj/templates/dj/vote.html
{% extends "dj/base.html" %}

{% block title %}Vote for next song{{ block.super }}{% endblock %}

{% block content %}

  <h1 class="text-center">Vote for next song</h1>

  <form method="get" class="full-form">
    <div class="input-group">
      <input type="search" name="q" class="form-control" accesskey="s"
             value="{{ request.GET.q }}"
             placeholder="Search available songs (Alt-s)">
      <span class="input-group-btn">
        {% if request.GET.q %}
          <a class="btn btn-default" href="?q=" accesskey="c" title="Clear search (Alt-c)"><i class="fa fa-times"></i></a>
        {% endif %}
        <button class="btn btn-primary" type="submit">
          <i class="fa fa-search"></i>
          Search
        </button>
      </span>
    </div>
  </form>

  <table class="table table-striped">
    <thead>
    <tr>
      <th>Artist</th>
      <th>Title</th>
      <th>Duration</th>
      <th>Votes</th>
      <th>Act</th>
    </tr>
    </thead>
    <tbody>
    {% for song in songs %}
      <tr>
        <td>{{ song.artist }}</td>
        <td>{{ song.title }}</td>
        <td>{{ song.human_duration }}</td>
        <td>{{ song.vote_count }}</td>
        <td>
          <form method="post">
            {% csrf_token %}
            <input type="hidden" name="song_id" value="{{ song.pk }}">
            <input type="hidden" name="next"
                   value="{% url 'dj:vote' %}?q={{ request.GET.q }}">
            {% if request.user in song.votes.all %}
              <button class="btn btn-danger btn-xs" name="action"
                      value="remove">
                <i class="fa fa-thumbs-down"></i>
              </button>
            {% else %}
              <button class="btn btn-success btn-xs" name="action" value="add">
                <i class="fa fa-thumbs-up"></i>
              </button>
            {% endif %}
          </form>
        </td>
      </tr>
    {% endfor %}
    </tbody>
  </table>

  {% include "dj/stub_pagination.html" %}

{% endblock %}